#include <stdint.h>

#include "HardwareSerial.h"
#include "hipc/arduino/ioutils.h"

/**
 * Read \c count bytes.
 *
 * @param buf Buffer into which the bytes are read
 * @param count Number of the bytes to read.
 */
void hipcArduinoReadExactly(void *buf, const size_t count)
{
    size_t n;
    size_t i;

    n = count;
    while (0 < n) {
        i = Serial.readBytes((char *) buf, n);
        buf = ((unsigned char *) buf) + i;
        /* assert that n >= i */
        n -= i;
    }
    return;
}

/**
 * Writes \c count bytes.
 *
 * @param buf Buffer from which bytes are written
 * @param count Number of bytes to write.
 */
void hipcArduinoWriteExactly(void const *buf, const size_t count)
{
    size_t n;
    size_t i;

    n = count;
    while (0 < n) {
        i = Serial.write((const unsigned char *) buf, n);
        buf = ((unsigned char *) buf) + i;
        /* assert that n >= i */
        n -= i;
    }
    Serial.flush();
    return;
}
