#ifndef HIPC_H
#define HIPC_H

enum HIPC_errno {
    HIPC_SUCCESS,

    HIPC_ERR_S_INV_UDATA,
    HIPC_ERR_S_INV_MSG_TYPE,
    HIPC_ERR_S_INV_STRUNO,
    HIPC_ERR_S_INV_RW_RANGE,
    HIPC_ERR_S_V_UNINIT_MSG,
    HIPC_ERR_S_IO_READ,
    HIPC_ERR_S_IO_WRITE,
    HIPC_ERR_S_INV_CFG,
    HIPC_ERR_S_INV_NULL,
    HIPC_ERR_S_BUF_SHTG,
    HIPC_ERR_S_OVERSIZED_STRU,
    HIPC_ERR_S_PBANK_STAT_MISMATCH,

    HIPC_ERR_C_STD,
    HIPC_ERR_INTERNAL_ERROR,
    HIPC_ERR_IO_READ,
    HIPC_ERR_IO_WRITE,
    HIPC_ERR_PROTOCOL_VIOLATION,
    HIPC_ERR_INV_ENDIAN,
    HIPC_ERR_INV_ID_STR,
    HIPC_ERR_INV_BASE_CLIENT,
    HIPC_ERR_MBR_SIZE_MISMATCH,
    HIPC_ERR_SESS_STATE_MISMATCH,

    HIPC_ERR_FOR_TESTING,
    HIPC_ERR_TEST_LIB_INTERNAL,
    HIPC_N_ERR
};

enum {
    HIPC_MSGHDR_BYTE_TYPE,
    HIPC_MSGHDR_BYTE_STRUNO,
    HIPC_MSGHDR_BYTE_OFFSET,
    HIPC_MSGHDR_BYTE_BDYSZ,
    HIPC_MSGHDR_SIZE            /* 4 */
};

#define HIPC_UNSTRU 255

#define HIPC_IMG_ALLOCSIZE 256
#define HIPC_MSG_ALLOCSIZE 260  /* 4+256 */

enum {
    HIPC_MESSAGE_TYPE_QUIT,
    HIPC_MESSAGE_TYPE_SUCCESS,
    HIPC_MESSAGE_TYPE_SYS,
    HIPC_MESSAGE_TYPE_CAST,
    HIPC_MESSAGE_TYPE_GET,
    HIPC_MESSAGE_TYPE_PUT,
    HIPC_MESSAGE_TYPE_BYE,
    HIPC_MESSAGE_TYPE_HELLO
};

enum {
    HIPC_SYSMSG_TYPE_OVERVIEW,
    HIPC_SYSMSG_TYPE_OFFSET,
    HIPC_SYSMSG_TYPE_SIZE
};

#ifdef __cplusplus
extern "C" {
#endif

    extern unsigned char hipcMsghdrBdysize(unsigned char const *const
                                           msghdr);
    extern unsigned char hipcEndian(void);

#ifdef __cplusplus
}
#endif
#endif
