#ifndef HIPC_SCFG_H
#define HIPC_SCFG_H

#include <stddef.h>

#include <hipc.h>
#include <hipc/msgd.h>

struct HIPC_scfg {
    unsigned char cfgid_header[HIPC_MSGHDR_SIZE];
    const unsigned char *cfgid;
    unsigned char *endian_p;
    unsigned int n_sysmsg;
    const struct HIPC_fixed_sysmsg *sysmsg_p;
    unsigned char n_struct;
    const size_t *strusize_p;
};

struct HIPC_fixed_sysmsg {
    const size_t size;
    const void *const ptr;
};

#ifdef __cplusplus
extern "C" {
#endif

    extern void hipcScfgInit(const struct HIPC_scfg *const cfg_p);
    extern enum HIPC_errno
     hipcScfgCheckStrusize(const struct HIPC_scfg *const cfg_p);

#ifdef __cplusplus
}
#endif
#endif
