#include <hipc/scfg.h>

/**
 * Initializes a server-side configuration.
 *
 * @param cfg_p pointer to a server-side configuration
 */
void hipcScfgInit(const struct HIPC_scfg *const cfg_p)
{
    *(cfg_p->endian_p) = hipcEndian();
    return;
}

/**
 * Checks structure sizes.
 *
 * @param cfg_p pointer to a server-side configuration
 * @returns HIPC_SUCCESS on success, or an error on failure.
 */
enum HIPC_errno hipcScfgCheckStrusize(const struct HIPC_scfg *const cfg_p)
{
    enum HIPC_errno retval;
    unsigned int i;

    retval = HIPC_SUCCESS;
    if (NULL != cfg_p->strusize_p) {
        for (i = 0; i < cfg_p->n_struct; ++i) {
            if (255 < cfg_p->strusize_p[i]) {
                return HIPC_ERR_S_OVERSIZED_STRU;
            }
        }
    }

    return retval;
}
